//----------------------------------------------------------------------------//
/*
 *  Copyright (c) 2002 - 2003 Phil Kerr [phil@plus24.com]
 *
 *  dmidi.cpp  Main QT DMIDI file for dpromix01
 *  http://www.dmidi.org
 *
 *  This  program is free software; you can redistribute it and/or modify it
 *  under the  terms  of  the GNU General Public License as published by the
 *  Free Software Foundation version 2 of the License.
 * 
 *  This  program  is  distributed  in  the hope that it will be useful, but
 *  WITHOUT   ANY   WARRANTY;   without   even  the   implied   warranty  of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 *  See the GNU General Public License for more details (see enclosed 
 *  file COPYING).
 * 
 *  You  should have received a copy of the GNU General Public License along
 *  with this  program; if not, write to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  $Id: alpha release $ 
 */
//----------------------------------------------------------------------------//

#include <qdom.h>
#include <qfile.h>
#include <qtooltip.h>
#include <qgroupbox.h>
#include <qstring.h>
#include <qvariant.h>
#include "dmidi.h"

//----------------------------------------------------------------------------//

#ifdef LINUX

#include <sys/types.h>
#include <sys/socket.h>
#include <net/if.h>
#include <net/if_packet.h>
#include <linux/if_ether.h>
#include <net/if_arp.h>
#include <sys/ioctl.h>

#include <arpa/inet.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>

#endif

//----------------------------------------------------------------------------//

QString nodename = "";
QString interface = "eth0";

int conf_loaded = 0;
bool xmlok = 0;
int outputmode = 0;
int broadcast = 0;

unsigned char n1 = DMIDI_BROADCAST_NODEBYTE1;
unsigned char n2 = DMIDI_BROADCAST_NODEBYTE2;
unsigned char n3 = DMIDI_BROADCAST_NODEBYTE3;
unsigned char n4 = DMIDI_BROADCAST_NODEBYTE4;

unsigned char databyte1 = 0xb0;
unsigned char databyte2 = 0;

QDomDocument doc ("mydocument");
#define BUFSIZE 1000

unsigned char midic = 0;

//----------------------------------------------------------------------------//
// urgh, globals for xml saving

int pan1;
int pan2;
int pan3;
int pan4;
int pan5;
int pan6;
int pan7;
int pan8;
int pan9;
int pan10;
int pan11;
int pan12;
int pan13;
int pan14;
int pan15;
int pan16;

int panstinl;
int panstinr;

int panret1l;
int panret1r;
int panret2l;
int panret2r;
int panret3;
//int panret3r;
int panret4;
//int panret4r;

int panstout;

int p1val;
int p2val;
int p3val;
int p4val;
int p5val;
int p6val;
int p7val;
int p8val;
int p9val;
int p10val;
int p11val;
int p12val;
int p13val;
int p14val;
int p15val;
int p16val;

int pstinlval;
int pstinrval;

int pret1lval;
int pret1rval;
int pret2lval;
int pret2rval;
int pret3val;
//int pret3rval;
int pret4val;
//int pret4rval;

int pstoutval;

int vol1;
int vol2;
int vol3;
int vol4;
int vol5;
int vol6;
int vol7;
int vol8;
int vol9;
int vol10;
int vol11;
int vol12;
int vol13;
int vol14;
int vol15;
int vol16;

int volstin;
int volret1;
int volret2;
int volret3;
int volret4;
int volstout;

int on_val1;
int on_val2;
int on_val3;
int on_val4;
int on_val5;
int on_val6;
int on_val7;
int on_val8;
int on_val9;
int on_val10;
int on_val11;
int on_val12;
int on_val13;
int on_val14;
int on_val15;
int on_val16;

int on_valstin;
int on_valret1;
int on_valret2;
int on_valret3;
int on_valret4;
int on_valstout;

int slider1val;
int slider2val;
int slider3val;
int slider4val;
int slider5val;
int slider6val;
int slider7val;
int slider8val;
int slider9val;
int slider10val;
int slider11val;
int slider12val;
int slider13val;
int slider14val;
int slider15val;
int slider16val;

int sliderstinval;
int sliderret1val;
int sliderret2val;
int sliderret3val;
int sliderret4val;
int sliderstoutval;

int onval1;
int onval2;
int onval3;
int onval4;
int onval5;
int onval6;
int onval7;
int onval8;
int onval9;
int onval10;
int onval11;
int onval12;
int onval13;
int onval14;
int onval15;
int onval16;

int onvalstin;
int onvalret1;
int onvalret2;
int onvalret3;
int onvalret4;
int onvalstout;

#ifdef LINUX

void dmidi::send_dmidi (unsigned char * dmidi_output, unsigned int len)
{
    int res = 0, xlen;
    struct sockaddr sa;
    struct sockaddr * sap = &sa;
    struct ifreq ifr;
    unsigned char buffer [1500];
    unsigned char ebroadcast [1];

    // create socket
    int s = socket (AF_INET, SOCK_PACKET, htons (ETH_P_ALL));

    if (s < 0) {
      perror ("socket");
    }

    if (sizeof (sa) < sizeof (struct sockaddr)) {
        printf ("illegal size %d, should be %d\n",
            sizeof (sa), sizeof (struct sockaddr));
    }

    // socket setup
    xlen = sizeof (sa);
    bzero (sap, xlen);
    sa.sa_family = AF_INET;
    strcpy (sa.sa_data, interface);

    bzero (&ifr, sizeof(ifr));
    strcpy (ifr.ifr_name, interface);
    if (ioctl (s, SIOCGIFHWADDR, &ifr) < 0) {
      perror ("ioctl(SIOCGIFHWADDR)");
    }

    ebroadcast [0] = 0xff;
    bzero (buffer, BUFSIZE);

    memcpy (buffer, ebroadcast, 6); // dest MAC
    memcpy (buffer + 6, ifr.ifr_hwaddr.sa_data, 6); // source MAC

    buffer [12] = 0x11;
    buffer [13] = 0x99;

    switch (broadcast) {
    case 0:
        // add node ID's to output packet
        buffer [14] = n1;
        buffer [15] = n2;
        buffer [16] = n3;
        buffer [17] = n4;
        break;
    case 2:
        memcpy (buffer + 14, ebroadcast, 4);
        break;
    }

    memcpy (buffer + 18, ebroadcast, 6);

    if (len < 44) buffer [24] = len;
    else buffer [24] = 0xff;

    memcpy (buffer + 25, dmidi_output, len);
    res = sendto (s, buffer, (25 + len), 0, sap, sizeof (sa));
    close (s);
}

#endif


//----------------------------------------------------------------------------//

void dmidi::setbroadcast (int inp)
{
    broadcast = inp;
}

//----------------------------------------------------------------------------//

void dmidi::volume_midi1 (int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = slider1val;
    payload[2] = (127 - inp);

    emit midi_value1 (127 - inp);
    send_dmidi (payload, len);
    vol1 = (127 - inp);
}

//----------------------------------------------------------------------------//

void dmidi::volume_midi2(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = slider2val;
    payload[2] = (127 - inp);

    emit midi_value2 (127 - inp);
    send_dmidi (payload, len);
    vol2 = (127 - inp);
}

//----------------------------------------------------------------------------//

void dmidi::volume_midi3(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = slider3val;
    payload[2] = (127 - inp);

    emit midi_value3 (127 - inp);
    send_dmidi (payload, len);
    vol3 = (127 - inp);
}

//----------------------------------------------------------------------------//

void dmidi::volume_midi4(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = slider4val;
    payload[2] = (127 - inp);

    emit midi_value4 (127 - inp);
    send_dmidi (payload, len);
    vol4 = (127 - inp);
}

//----------------------------------------------------------------------------//

void dmidi::volume_midi5(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = slider5val;
    payload[2] = (127 - inp);

    emit midi_value5 (127 - inp);
    send_dmidi (payload, len);
    vol5 = (127 - inp);
}

//----------------------------------------------------------------------------//

void dmidi::volume_midi6(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = slider6val;
    payload[2] = (127 - inp);

    emit midi_value6 (127 - inp);
    send_dmidi (payload, len);
    vol6 = (127 - inp);
}

//----------------------------------------------------------------------------//

void dmidi::volume_midi7(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = slider7val;
    payload[2] = (127 - inp);

    emit midi_value7 (127 - inp);
    send_dmidi (payload, len);
    vol7 = (127 - inp);
}

//----------------------------------------------------------------------------//

void dmidi::volume_midi8(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = slider8val;
    payload[2] = (127 - inp);

    emit midi_value8 (127 - inp);
    send_dmidi (payload, len);
    vol8 = (127 - inp);
}

//----------------------------------------------------------------------------//

void dmidi::volume_midi9(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = slider9val;
    payload[2] = (127 - inp);

    emit midi_value9 (127 - inp);
    send_dmidi (payload, len);
    vol9 = (127 - inp);
}

//----------------------------------------------------------------------------//

void dmidi::volume_midi10(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = slider10val;
    payload[2] = (127 - inp);

    emit midi_value10 (127 - inp);
    send_dmidi (payload, len);
    vol10 = (127 - inp);
}

//----------------------------------------------------------------------------//

void dmidi::volume_midi11(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = slider11val;
    payload[2] = (127 - inp);

    emit midi_value11 (127 - inp);
    send_dmidi (payload, len);
    vol11 = (127 - inp);
}

//----------------------------------------------------------------------------//

void dmidi::volume_midi12(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = slider12val;
    payload[2] = (127 - inp);

    emit midi_value12 (127 - inp);
    send_dmidi (payload, len);
    vol12 = (127 - inp);
}

//----------------------------------------------------------------------------//

void dmidi::volume_midi13(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = slider13val;
    payload[2] = (127 - inp);

    emit midi_value13 (127 - inp);
    send_dmidi (payload, len);
    vol13 = (127 - inp);
}

//----------------------------------------------------------------------------//

void dmidi::volume_midi14(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = slider14val;
    payload[2] = (127 - inp);

    emit midi_value14 (127 - inp);
    send_dmidi (payload, len);
    vol14 = (127 - inp);
}

//----------------------------------------------------------------------------//

void dmidi::volume_midi15(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = slider15val;
    payload[2] = (127 - inp);

    emit midi_value15 (127 - inp);
    send_dmidi (payload, len);
    vol15 = (127 - inp);
}

//----------------------------------------------------------------------------//

void dmidi::volume_midi16(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = slider16val;
    payload[2] = (127 - inp);

    emit midi_value16 (127 - inp);
    send_dmidi (payload, len);
    vol16 = (127 - inp);
}

//----------------------------------------------------------------------------//

void dmidi::volume_midistin(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = sliderstinval;
    payload[2] = (127 - inp);

    emit midi_valuestin (127 - inp);
    send_dmidi (payload, len);
    volstin = (127 - inp);
}

//----------------------------------------------------------------------------//

void dmidi::volume_send1 (int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = sliderret1val;
    payload[2] = (127 - inp);

    emit midi_valuesend1 (127 - inp);
    send_dmidi (payload, len);
    volret1 = (127 - inp);
}

//----------------------------------------------------------------------------//

void dmidi::volume_send2 (int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = sliderret2val;
    payload[2] = (127 - inp);

    emit midi_valuesend2 (127 - inp);
    send_dmidi (payload, len);
    volret2 = (127 - inp);
}

//----------------------------------------------------------------------------//

void dmidi::volume_send3 (int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = sliderret3val;
    payload[2] = (127 - inp);

    emit midi_valuesend3 (127 - inp);
    send_dmidi (payload, len);
    volret3 = (127 - inp);
}

//----------------------------------------------------------------------------//

void dmidi::volume_send4 (int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = sliderret4val;
    payload[2] = (127 - inp);

    emit midi_valuesend4 (127 - inp);
    send_dmidi (payload, len);
    volret4 = (127 - inp);
}

//----------------------------------------------------------------------------//

void dmidi::volume_midistout (int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = sliderstoutval;
    payload[2] = (127 - inp);

    emit midi_valuestout (127 - inp);
    send_dmidi (payload, len);
    volstout = (127 - inp);
}

//----------------------------------------------------------------------------//

void dmidi::pan_midi1(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = p1val;
    payload[2] = (127 - inp);

    emit pan_value1 ((inp) - 64);
    send_dmidi (payload, len);
    pan1 = inp;
}

//----------------------------------------------------------------------------//

void dmidi::pan_midi2(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = p2val;
    payload[2] = (127 - inp);

    emit pan_value2 ((inp) - 64);
    send_dmidi (payload, len);
    pan2 = inp;
}

//----------------------------------------------------------------------------//

void dmidi::pan_midi3(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = p3val;
    payload[2] = (127 - inp);

    emit pan_value3 ((inp) - 64);
    send_dmidi (payload, len);
    pan3 = inp;
}

//----------------------------------------------------------------------------//

void dmidi::pan_midi4(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = p4val;
    payload[2] = (127 - inp);

    emit pan_value4 ((inp) - 64);
    send_dmidi (payload, len);
    pan4 = inp;
}

//----------------------------------------------------------------------------//

void dmidi::pan_midi5(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = p5val;
    payload[2] = (127 - inp);

    emit pan_value5 ((inp) - 64);
    send_dmidi (payload, len);
    pan5 = inp;
}

//----------------------------------------------------------------------------//

void dmidi::pan_midi6(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = p6val;
    payload[2] = (127 - inp);

    emit pan_value6 ((inp) - 64);
    send_dmidi (payload, len);
    pan6 = inp;
}

//----------------------------------------------------------------------------//

void dmidi::pan_midi7(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = p7val;
    payload[2] = (127 - inp);

    emit pan_value7 ((inp) - 64);
    send_dmidi (payload, len);
    pan7 = inp;
}

//----------------------------------------------------------------------------//

void dmidi::pan_midi8(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = p8val;
    payload[2] = (127 - inp);

    emit pan_value8 ((inp) - 64);
    send_dmidi (payload, len);
    pan8 = inp;
}

//----------------------------------------------------------------------------//

void dmidi::pan_midi9(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = p9val;
    payload[2] = (127 - inp);

    emit pan_value9 ((inp) - 64);
    send_dmidi (payload, len);
    pan9 = inp;
}

//----------------------------------------------------------------------------//

void dmidi::pan_midi10(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = p10val;
    payload[2] = (127 - inp);

    emit pan_value10 ((inp) - 64);
    send_dmidi (payload, len);
    pan10 = inp;
}

//----------------------------------------------------------------------------//

void dmidi::pan_midi11(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = p11val;
    payload[2] = (127 - inp);

    emit pan_value11 ((inp) - 64);
    send_dmidi (payload, len);
    pan11 = inp;
}

//----------------------------------------------------------------------------//

void dmidi::pan_midi12(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = p12val;
    payload[2] = (127 - inp);

    emit pan_value12 ((inp) - 64);
    send_dmidi (payload, len);
    pan12 = inp;
}

//----------------------------------------------------------------------------//

void dmidi::pan_midi13(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = p13val;
    payload[2] = (127 - inp);

    emit pan_value13 ((inp) - 64);
    send_dmidi (payload, len);
    pan13 = inp;
}

//----------------------------------------------------------------------------//

void dmidi::pan_midi14(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = p14val;
    payload[2] = (127 - inp);

    emit pan_value14 ((inp) - 64);
    send_dmidi (payload, len);
    pan14 = inp;
}

//----------------------------------------------------------------------------//

void dmidi::pan_midi15(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = p15val;
    payload[2] = (127 - inp);

    emit pan_value15 ((inp) - 64);
    send_dmidi (payload, len);
    pan15 = inp;
}

//----------------------------------------------------------------------------//

void dmidi::pan_midi16(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = p16val;
    payload[2] = (127 - inp);

    emit pan_value16 ((inp) - 64);
    send_dmidi (payload, len);
    pan16 = inp;
}

//----------------------------------------------------------------------------//

void dmidi::pan_midistinl(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = pstinlval;
    payload[2] = (127 - inp);

    emit pan_valuestinl ((inp) - 64);
    send_dmidi (payload, len);
    panstinl = inp;
}

//----------------------------------------------------------------------------//

void dmidi::pan_midistinr(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = pstinrval;
    payload[2] = (127 - inp);

    emit pan_valuestinr ((inp) - 64);
    send_dmidi (payload, len);
    panstinr = inp;
}

//----------------------------------------------------------------------------//

void dmidi::pan_midiret1l(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = pret1lval;
    payload[2] = (127 - inp);

    emit pan_valueret1l ((inp) - 64);
    send_dmidi (payload, len);
    panret1l = inp;
}

//----------------------------------------------------------------------------//

void dmidi::pan_midiret1r(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = pret1rval;
    payload[2] = (127 - inp);

    emit pan_valueret1r ((inp) - 64);
    send_dmidi (payload, len);
    panret1r = inp;
}

//----------------------------------------------------------------------------//

void dmidi::pan_midiret2l(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = pret2lval;
    payload[2] = (127 - inp);

    emit pan_valueret2l ((inp) - 64);
    send_dmidi (payload, len);
    panret2l = inp;
}

//----------------------------------------------------------------------------//

void dmidi::pan_midiret2r(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = pret2rval;
    payload[2] = (127 - inp);

    emit pan_valueret2r ((inp) - 64);
    send_dmidi (payload, len);
    panret2r = inp;
}

//----------------------------------------------------------------------------//

void dmidi::pan_midiret3(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = pret3val;
    payload[2] = (127 - inp);

    emit pan_valueret3 ((inp) - 64);
    send_dmidi (payload, len);
    panret3 = inp;
}

//----------------------------------------------------------------------------//

void dmidi::pan_midiret4(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = pret4val;
    payload[2] = (127 - inp);

    emit pan_valueret4 ((inp) - 64);
    send_dmidi (payload, len);
    panret4 = inp;
}

//----------------------------------------------------------------------------//

void dmidi::pan_midistout(int inp)
{
    int len = 3;
    unsigned char payload [len];

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = pstoutval;
    payload[2] = (127 - inp);

    emit pan_valuestout ((inp) - 64);
    send_dmidi (payload, len);
    panstout = inp;
}

//----------------------------------------------------------------------------//

void dmidi::on1(int inp)
{
    int len = 3;
    unsigned int value;
    unsigned char payload [len];

    if (inp == 0) {
        value = 0;
    } else {
        value = 0x7f;
    }

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = onval1;
    payload[2] = value;

    send_dmidi(payload, len);
    if (value == 0) on_val1 = 0;
    if (value == 0x7f) on_val1 = 1;
}

//----------------------------------------------------------------------------//

void dmidi::on2(int inp)
{
    int len = 3;
    unsigned int value;
    unsigned char payload [len];

    if (inp == 0) {
        value = 0;
    } else {
        value = 0x7f;
    }

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = onval2;
    payload[2] = value;

    send_dmidi(payload, len);
    if (value == 0) on_val2 = 0;
    if (value == 0x7f) on_val2 = 1;
}

//----------------------------------------------------------------------------//

void dmidi::on3(int inp)
{
    int len = 3;
    unsigned int value;
    unsigned char payload [len];

    if (inp == 0) {
        value = 0;
    } else {
        value = 0x7f;
    }

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = onval3;
    payload[2] = value;

    send_dmidi(payload, len);
    if (value == 0) on_val3 = 0;
    if (value == 0x7f) on_val3 = 1;
}

//----------------------------------------------------------------------------//

void dmidi::on4(int inp)
{
    int len = 3;
    unsigned int value;
    unsigned char payload [len];

    if (inp == 0) {
        value = 0;
    } else {
        value = 0x7f;
    }

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = onval4;
    payload[2] = value;

    send_dmidi(payload, len);
    if (value == 0) on_val4 = 0;
    if (value == 0x7f) on_val4 = 1;
}

//----------------------------------------------------------------------------//

void dmidi::on5(int inp)
{
    int len = 3;
    unsigned int value;
    unsigned char payload [len];

    if (inp == 0) {
        value = 0;
    } else {
        value = 0x7f;
    }

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = onval5;
    payload[2] = value;

    send_dmidi(payload, len);
    if (value == 0) on_val5 = 0;
    if (value == 0x7f) on_val5 = 1;
}

//----------------------------------------------------------------------------//

void dmidi::on6(int inp)
{
    int len = 3;
    unsigned int value;
    unsigned char payload [len];

    if (inp == 0) {
        value = 0;
    } else {
        value = 0x7f;
    }

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = onval6;
    payload[2] = value;

    send_dmidi(payload, len);
    if (value == 0) on_val6 = 0;
    if (value == 0x7f) on_val6 = 1;
}

//----------------------------------------------------------------------------//

void dmidi::on7(int inp)
{
    int len = 3;
    unsigned int value;
    unsigned char payload [len];

    if (inp == 0) {
        value = 0;
    } else {
        value = 0x7f;
    }

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = onval7;
    payload[2] = value;

    send_dmidi(payload, len);
    if (value == 0) on_val7 = 0;
    if (value == 0x7f) on_val7 = 1;
}

//----------------------------------------------------------------------------//

void dmidi::on8(int inp)
{
    int len = 3;
    unsigned int value;
    unsigned char payload [len];

    if (inp == 0) {
        value = 0;
    } else {
        value = 0x7f;
    }

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = onval8;
    payload[2] = value;

    send_dmidi(payload, len);
    if (value == 0) on_val8 = 0;
    if (value == 0x7f) on_val8 = 1;
}

//----------------------------------------------------------------------------//

void dmidi::on9(int inp)
{
    int len = 3;
    unsigned int value;
    unsigned char payload [len];

    if (inp == 0) {
        value = 0;
    } else {
        value = 0x7f;
    }

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = onval9;
    payload[2] = value;

    send_dmidi(payload, len);
    if (value == 0) on_val9 = 0;
    if (value == 0x7f) on_val9 = 1;
}

//----------------------------------------------------------------------------//

void dmidi::on10(int inp)
{
    int len = 3;
    unsigned int value;
    unsigned char payload [len];

    if (inp == 0) {
        value = 0;
    } else {
        value = 0x7f;
    }

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = onval10;
    payload[2] = value;

    send_dmidi(payload, len);
    if (value == 0) on_val10 = 0;
    if (value == 0x7f) on_val10 = 1;
}

//----------------------------------------------------------------------------//

void dmidi::on11(int inp)
{
    int len = 3;
    unsigned int value;
    unsigned char payload [len];

    if (inp == 0) {
        value = 0;
    } else {
        value = 0x7f;
    }

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = onval11;
    payload[2] = value;

    send_dmidi(payload, len);
    if (value == 0) on_val11 = 0;
    if (value == 0x7f) on_val11 = 1;
}

//----------------------------------------------------------------------------//

void dmidi::on12(int inp)
{
    int len = 3;
    unsigned int value;
    unsigned char payload [len];

    if (inp == 0) {
        value = 0;
    } else {
        value = 0x7f;
    }

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = onval12;
    payload[2] = value;

    send_dmidi(payload, len);
    if (value == 0) on_val12 = 0;
    if (value == 0x7f) on_val12 = 1;
}

//----------------------------------------------------------------------------//

void dmidi::on13(int inp)
{
    int len = 3;
    unsigned int value;
    unsigned char payload [len];

    if (inp == 0) {
        value = 0;
    } else {
        value = 0x7f;
    }

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = onval13;
    payload[2] = value;

    send_dmidi(payload, len);
    if (value == 0) on_val13 = 0;
    if (value == 0x7f) on_val13 = 1;
}

//----------------------------------------------------------------------------//

void dmidi::on14(int inp)
{
    int len = 3;
    unsigned int value;
    unsigned char payload [len];

    if (inp == 0) {
        value = 0;
    } else {
        value = 0x7f;
    }

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = onval14;
    payload[2] = value;

    send_dmidi(payload, len);
    if (value == 0) on_val14 = 0;
    if (value == 0x7f) on_val14 = 1;
}

//----------------------------------------------------------------------------//

void dmidi::on15(int inp)
{
    int len = 3;
    unsigned int value;
    unsigned char payload [len];

    if (inp == 0) {
        value = 0;
    } else {
        value = 0x7f;
    }

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = onval15;
    payload[2] = value;

    send_dmidi(payload, len);
    if (value == 0) on_val15 = 0;
    if (value == 0x7f) on_val15 = 1;
}

//----------------------------------------------------------------------------//

void dmidi::on16(int inp)
{
    int len = 3;
    unsigned int value;
    unsigned char payload [len];

    if (inp == 0) {
        value = 0;
    } else {
        value = 0x7f;
    }

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = onval16;
    payload[2] = value;

    send_dmidi(payload, len);
    if (value == 0) on_val16 = 0;
    if (value == 0x7f) on_val16 = 1;
}

//----------------------------------------------------------------------------//

void dmidi::onstin(int inp)
{
    int len = 3;
    unsigned int value;
    unsigned char payload [len];

    if (inp == 0) {
        value = 0;
    } else {
        value = 0x7f;
    }

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = onvalstin;
    payload[2] = value;

    send_dmidi(payload, len);
    if (value == 0) on_valstin = 0;
    if (value == 0x7f) on_valstin = 1;
}

//----------------------------------------------------------------------------//

void dmidi::onret1(int inp)
{
    int len = 3;
    unsigned int value;
    unsigned char payload [len];

    if (inp == 0) {
        value = 0;
    } else {
        value = 0x7f;
    }

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = onvalret1;
    payload[2] = value;

    send_dmidi(payload, len);
    if (value == 0) on_valret1 = 0;
    if (value == 0x7f) on_valret1 = 1;
}

//----------------------------------------------------------------------------//

void dmidi::onret2(int inp)
{
    int len = 3;
    unsigned int value;
    unsigned char payload [len];

    if (inp == 0) {
        value = 0;
    } else {
        value = 0x7f;
    }

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = onvalret2;
    payload[2] = value;

    send_dmidi(payload, len);
    if (value == 0) on_valret2 = 0;
    if (value == 0x7f) on_valret2 = 1;
}

//----------------------------------------------------------------------------//

void dmidi::onret3(int inp)
{
    int len = 3;
    unsigned int value;
    unsigned char payload [len];

    if (inp == 0) {
        value = 0;
    } else {
        value = 0x7f;
    }

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = onvalret3;
    payload[2] = value;

    send_dmidi(payload, len);
    if (value == 0) on_valret3 = 0;
    if (value == 0x7f) on_valret3 = 1;
}

//----------------------------------------------------------------------------//

void dmidi::onret4(int inp)
{
    int len = 3;
    unsigned int value;
    unsigned char payload [len];

    if (inp == 0) {
        value = 0;
    } else {
        value = 0x7f;
    }

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = onvalret4;
    payload[2] = value;

    send_dmidi(payload, len);
    if (value == 0) on_valret4 = 0;
    if (value == 0x7f) on_valret4 = 1;
}

//----------------------------------------------------------------------------//

void dmidi::onstout(int inp)
{
    int len = 3;
    unsigned int value;
    unsigned char payload [len];

    if (inp == 0) {
        value = 0;
    } else {
        value = 0x7f;
    }

    payload[0] = 0xB0 + (midic - 1);
    payload[1] = onvalstout;
    payload[2] = value;

    send_dmidi(payload, len);
    if (value == 0) on_valstout = 0;
    if (value == 0x7f) on_valstout = 1;
}

//----------------------------------------------------------------------------//

void dmidi::midichan (int imp)
{
    midic = imp;
}

//----------------------------------------------------------------------------//

void dmidi::send1effects (int inp)
{

unsigned char payload [20]; 
int len = 3;

payload[0] = (0xb4);
payload[1] = 20;
payload[2] = inp;

//emit midi_value10 (127 - inp);
//vol10 = inp;

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send1slider1(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 68;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);
emit setsend1slider1 (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send1slider2 (int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 69;

unsigned char payload [10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);
emit setsend1slider2 (127 - inp);

send_dmidi(payload, len);
}
//----------------------------------------------------------------------------//

void dmidi::send1slider3(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 70;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);
emit setsend1slider3 (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send1slider4(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 71;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);
emit setsend1slider4 (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send1slider5(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 72;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send1slider6(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 73;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send1slider7(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 74;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send1slider8(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 75;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send1slider9(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 76;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send1slider10(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 77;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send1slider11(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 78;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send1slider12(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 79;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send1slider13(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 80;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send1slider14(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 81;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send1slider15(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 82;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send1slider16(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 83;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send1slider17(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 84;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send1slider18(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 17;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send1slider19(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 21;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send2effects(int inp)
{

unsigned char payload [20]; 
int len = 3;

payload[0] = (0xb4);
payload[1] = 21;
payload[2] = inp;

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send2slider1(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 85;
unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send2slider2 (int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 86;

unsigned char payload [10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi(payload, len);
}
//----------------------------------------------------------------------------//

void dmidi::send2slider3(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 87;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send2slider4(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 88;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send2slider5(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 89;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send2slider6(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 90;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send2slider7(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 91;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send2slider8(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 92;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send2slider9(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 93;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send2slider10(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 94;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send2slider11(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 95;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send2slider12(int inp)
{

unsigned char d1 = (0xB1 + (midic - 1)); 
unsigned char d2 = 0;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send2slider13(int inp)
{

unsigned char d1 = (0xB1 + (midic - 1)); 
unsigned char d2 = 1;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send2slider14(int inp)
{

unsigned char d1 = (0xB1 + (midic - 1)); 
unsigned char d2 = 2;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send2slider15(int inp)
{

unsigned char d1 = (0xB1 + (midic - 1)); 
unsigned char d2 = 3;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send2slider16(int inp)
{

unsigned char d1 = (0xB1 + (midic - 1)); 
unsigned char d2 = 4;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send2slider17(int inp)
{

unsigned char d1 = (0xb1 + (midic - 1)); 
unsigned char d2 = 5;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send2slider18(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 18;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//

void dmidi::send2slider19(int inp)
{

unsigned char d1 = (0xB0 + (midic - 1)); 
unsigned char d2 = 21;

unsigned char payload[10];
int len = 3;

payload[0] = d1;
payload[1] = d2;
payload[2] = (127 - inp);

send_dmidi (payload, len);
}

//----------------------------------------------------------------------------//
//  Set node id 1 slot

void dmidi::setnode1 (const QString& copyNode)
{
    n1 = copyNode.toInt (&xmlok, 16);   
}

//----------------------------------------------------------------------------//
//  Set node id 2 slot

void dmidi::setnode2 (const QString& copyNode)
{
    n2 = copyNode.toInt (&xmlok, 16);   
}

//----------------------------------------------------------------------------//
//  Set node id 3 slot

void dmidi::setnode3 (const QString& copyNode)
{
    n3 = copyNode.toInt (&xmlok, 16);   
}

//----------------------------------------------------------------------------//
//  Set node id 4 slot

void dmidi::setnode4 (const QString& copyNode)
{
    n4 = copyNode.toInt (&xmlok, 16);   
}

//----------------------------------------------------------------------------//
//  Set node id 3 slot

void dmidi::setbyte1 (const QString& Data)
{
    databyte1 = Data.toInt (&xmlok, 16);   
}

//----------------------------------------------------------------------------//
//  Set node id 4 slot

void dmidi::setbyte2 (const QString& Data)
{
    databyte2 = Data.toInt (&xmlok, 16);   
}

//----------------------------------------------------------------------------//
//  Restore settings to orig

void dmidi::restore (void)
{
    conf_loaded = 0;  
}

//----------------------------------------------------------------------------//
//  Load config slot

void dmidi::load_config ()
{

    int len = 2;
    unsigned char payload [len];

    if (conf_loaded != 1) {

    payload[0] = 0xC0 + (midic - 1);
    payload[1] = 0;

    send_dmidi (payload, len);


    QFile conf_file ("dpromix01.xml");

    if (!conf_file.open (IO_ReadOnly)) {
        qDebug ("config file read failed");
    }

    if (!doc.setContent (&conf_file)) {
        qDebug ("config file parse failed");
        conf_file.close ();
    }

    conf_file.close ();


    QDomElement docElem = doc.documentElement ();

    QDomNode n = docElem.firstChild();

    while( !n.isNull() ) {

        // try to convert the node to an element.
        QDomElement e = n.toElement(); 

        // the node was really an element.
        if( !e.isNull() ) { 

        // set vars from config xml file
             
              if (e.tagName () == "Interface") {
                  interface = (e.text());
              }

              //--------------------------------------------------------------//

              if (e.tagName() == "MidiChan") {
                  midichan((e.text()).toInt(&xmlok, 10));
                  emit setmidichan ((e.text()).toInt(&xmlok, 10));
              }

              if (e.tagName () == "NodeName") {
                  nodename = (e.text());
                  emit setnodename (e.text());
              }

              //--------------------------------------------------------------//

              if (e.tagName() == "Node1") {
                  n1 =  e.text().toUInt(&xmlok, 16);
                  emit node1 (e.text());
              }

              if (e.tagName() == "Node2") {
                  n2 =  e.text().toUInt(&xmlok, 16);
                  emit node2 (e.text());
              }

              if (e.tagName() == "Node3") {
                  n3 =  e.text().toUInt(&xmlok, 16);
                  emit node3 (e.text());
              }

              if (e.tagName() == "Node4") {
                  n4 =  e.text().toUInt(&xmlok, 16);
                  emit node4 (e.text());
              }

              if (e.tagName() == "Slider1Val") {
                  slider1val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Slider2Val") {
                  slider2val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Slider3Val") {
                  slider3val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Slider4Val") {
                  slider4val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Slider5Val") {
                  slider5val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Slider6Val") {
                  slider6val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Slider7Val") {
                  slider7val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Slider8Val") {
                  slider8val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Slider9Val") {
                  slider9val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Slider10Val") {
                  slider10val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Slider11Val") {
                  slider11val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Slider12Val") {
                  slider12val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Slider13Val") {
                  slider13val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Slider14Val") {
                  slider14val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Slider15Val") {
                  slider15val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Slider16Val") {
                  slider16val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "SliderStinVal") {
                  sliderstinval =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "SliderRet1Val") {
                  sliderret1val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "SliderRet2Val") {
                  sliderret2val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "SliderRet3Val") {
                  sliderret3val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "SliderRet4Val") {
                  sliderret4val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "SliderStoutVal") {
                  sliderstoutval =  e.text().toUInt(&xmlok, 10);
              }

              //--------------------------------------------------------------//

              if (e.tagName() == "On1Val") {
                  onval1 =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "On2Val") {
                  onval2 =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "On3Val") {
                  onval3 =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "On4Val") {
                  onval4 =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "On5Val") {
                  onval5 =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "On6Val") {
                  onval6 =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "On7Val") {
                  onval7 =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "On8Val") {
                  onval8 =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "On9Val") {
                  onval9 =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "On10Val") {
                  onval10 =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "On11Val") {
                  onval11 =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "On12Val") {
                  onval12 =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "On13Val") {
                  onval13 =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "On14Val") {
                  onval14 =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "On15Val") {
                  onval15 =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "On16Val") {
                  onval16 =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "OnStinVal") {
                  onvalstin =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "OnRet1Val") {
                  onvalret1 =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "OnRet2Val") {
                  onvalret2 =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "OnRet3Val") {
                  onvalret3 =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "OnRet4Val") {
                  onvalret4 =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "OnStoutVal") {
                  onvalstout =  e.text().toUInt(&xmlok, 10);
              }


              //--------------------------------------------------------------//

              if (e.tagName() == "Pan1Val") {
                  p1val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Pan2Val") {
                  p2val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Pan3Val") {
                  p3val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Pan4Val") {
                  p4val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Pan5Val") {
                  p5val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Pan6Val") {
                  p6val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Pan7Val") {
                  p7val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Pan8Val") {
                  p8val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Pan9Val") {
                  p9val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Pan10Val") {
                  p10val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Pan11Val") {
                  p11val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Pan12Val") {
                  p12val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Pan13Val") {
                  p13val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Pan14Val") {
                  p14val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Pan15Val") {
                  p15val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "Pan16Val") {
                  p16val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "PanStinLVal") {
                  pstinlval =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "PanStinRVal") {
                  pstinrval =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "PanRet1LVal") {
                  pret1lval =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "PanRet1RVal") {
                  pret1rval =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "PanRet2LVal") {
                  pret2lval =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "PanRet2RVal") {
                  pret2rval =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "PanRet3Val") {
                  pret3val =  e.text().toUInt(&xmlok, 10);
              }

/*              if (e.tagName() == "PanRet3RVal") {
                  pret3rval =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "PanRet4LVal") {
                  pret4lval =  e.text().toUInt(&xmlok, 10);
              }
*/
              if (e.tagName() == "PanRet4Val") {
                  pret4val =  e.text().toUInt(&xmlok, 10);
              }

              if (e.tagName() == "PanStoutVal") {
                  pstoutval =  e.text().toUInt(&xmlok, 10);
              }



              //--------------------------------------------------------------//
              // set main vol sliders

              if (e.tagName() == "Vol1") {
                  emit setvol1 (127 - ((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Vol2") {
                  emit setvol2 (127 - ((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Vol3") {
                  emit setvol3 (127 - ((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Vol4") {
                  emit setvol4 (127 - ((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Vol5") {
                  emit setvol5 (127 - ((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Vol6") {
                  emit setvol6 (127 - ((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Vol7") {
                  emit setvol7 (127 - ((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Vol8") {
                  emit setvol8 (127 - ((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Vol9") {
                  emit setvol9 (127 - ((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Vol10") {
                  emit setvol10 (127 - ((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Vol11") {
                  emit setvol11 (127 - ((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Vol12") {
                  emit setvol12 (127 - ((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Vol13") {
                  emit setvol13 (127 - ((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Vol14") {
                  emit setvol14 (127 - ((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Vol15") {
                  emit setvol15 (127 - ((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Vol16") {
                  emit setvol16 (127 - ((e.text()).toInt(&xmlok, 10)));
              }


              if (e.tagName() == "VolStin") {
                  emit setvolstin (127 - ((e.text()).toInt (&xmlok, 10)));
                  emit midi_valuestin ((e.text()).toInt (&xmlok, 10));
              }

              if (e.tagName() == "VolRet1") {
                  emit setvolret1 (127 - ((e.text()).toInt (&xmlok, 10)));
                  emit midi_valuesend1 ((e.text()).toInt (&xmlok, 10));
              }

              if (e.tagName() == "VolRet2") {
                  emit setvolret2 (127 - ((e.text()).toInt (&xmlok, 10)));
                  emit midi_valuesend2 ((e.text()).toInt (&xmlok, 10));
              }

              if (e.tagName() == "VolRet3") {
                  emit setvolret3 (127 - ((e.text()).toInt (&xmlok, 10)));
                  emit midi_valuesend3 ((e.text()).toInt (&xmlok, 10));
              }

              if (e.tagName() == "VolRet4") {
                  emit setvolret4 (127 - ((e.text()).toInt (&xmlok, 10)));
                  emit midi_valuesend4 ((e.text()).toInt (&xmlok, 10));
              }

              if (e.tagName() == "VolStout") {
                  emit setvolstout (127 - ((e.text()).toInt (&xmlok, 10)));
                  emit midi_valuestout ((e.text()).toInt (&xmlok, 10));
              }

              //--------------------------------------------------------------//
              // this sets the on button group 

              if (e.tagName() == "On1") {
                  if ( (e.text()).toInt(&xmlok, 10) == 0 ) {emit seton1 (FALSE); on1(0);}; 
                  if ( (e.text()).toInt(&xmlok, 10) == 1 ) emit seton1 (TRUE);
              }

              if (e.tagName() == "On2") {
                  if ( (e.text()).toInt(&xmlok, 10) == 0 ) {emit seton2 (FALSE); on2(0);}; 
                  if ( (e.text()).toInt(&xmlok, 10) == 1 ) emit seton2 (TRUE);
              }

              if (e.tagName() == "On3") {
                  if ( (e.text()).toInt(&xmlok, 10) == 0 ) {emit seton3 (FALSE); on3(0);}; 
                  if ( (e.text()).toInt(&xmlok, 10) == 1 ) emit seton3 (TRUE);
              }

              if (e.tagName() == "On4") {
                  if ( (e.text()).toInt(&xmlok, 10) == 0 ) {emit seton4 (FALSE); on4(0);}; 
                  if ( (e.text()).toInt(&xmlok, 10) == 1 ) emit seton4 (TRUE);
              }

              if (e.tagName() == "On5") {
                  if ( (e.text()).toInt(&xmlok, 10) == 0 ) {emit seton5 (FALSE); on5(0);}; 
                  if ( (e.text()).toInt(&xmlok, 10) == 1 ) emit seton5 (TRUE);
              }

              if (e.tagName() == "On6") {
                  if ( (e.text()).toInt(&xmlok, 10) == 0 ) {emit seton6 (FALSE); on6(0);}; 
                  if ( (e.text()).toInt(&xmlok, 10) == 1 ) emit seton6 (TRUE);
              }

              if (e.tagName() == "On7") {
                  if ( (e.text()).toInt(&xmlok, 10) == 0 ) {emit seton7 (FALSE); on7(0);}; 
                  if ( (e.text()).toInt(&xmlok, 10) == 1 ) emit seton7 (TRUE);
              }

              if (e.tagName() == "On8") {
                  if ( (e.text()).toInt(&xmlok, 10) == 0 ) {emit seton8 (FALSE); on8(0);}; 
                  if ( (e.text()).toInt(&xmlok, 10) == 1 ) emit seton8 (TRUE);
              }

              if (e.tagName() == "On9") {
                  if ( (e.text()).toInt(&xmlok, 10) == 0 ) {emit seton9 (FALSE); on9(0);}; 
                  if ( (e.text()).toInt(&xmlok, 10) == 1 ) emit seton9 (TRUE);
              }

              if (e.tagName() == "On10") {
                  if ( (e.text()).toInt(&xmlok, 10) == 0 ) {emit seton10 (FALSE); on10(0);}; 
                  if ( (e.text()).toInt(&xmlok, 10) == 1 ) emit seton10 (TRUE);
              }

              if (e.tagName() == "On11") {
                  if ( (e.text()).toInt(&xmlok, 10) == 0 ) {emit seton11 (FALSE); on11(0);}; 
                  if ( (e.text()).toInt(&xmlok, 10) == 1 ) emit seton11 (TRUE);
              }

              if (e.tagName() == "On12") {
                  if ( (e.text()).toInt(&xmlok, 10) == 0 ) {emit seton12 (FALSE); on12(0);}; 
                  if ( (e.text()).toInt(&xmlok, 10) == 1 ) emit seton12 (TRUE);
              }

              if (e.tagName() == "On13") {
                  if ( (e.text()).toInt(&xmlok, 10) == 0 ) {emit seton13 (FALSE); on13(0);}; 
                  if ( (e.text()).toInt(&xmlok, 10) == 1 ) emit seton13 (TRUE);
              }

              if (e.tagName() == "On14") {
                  if ( (e.text()).toInt(&xmlok, 10) == 0 ) {emit seton14 (FALSE); on14(0);}; 
                  if ( (e.text()).toInt(&xmlok, 10) == 1 ) emit seton14 (TRUE);
              }

              if (e.tagName() == "On15") {
                  if ( (e.text()).toInt(&xmlok, 10) == 0 ) {emit seton15 (FALSE); on15(0);}; 
                  if ( (e.text()).toInt(&xmlok, 10) == 1 ) emit seton15 (TRUE);
              }

              if (e.tagName() == "On16") {
                  if ( (e.text()).toInt(&xmlok, 10) == 0 ) {emit seton16 (FALSE); on16(0);}; 
                  if ( (e.text()).toInt(&xmlok, 10) == 1 ) emit seton16 (TRUE);
              }

              if (e.tagName() == "OnStin") {
                  if ( (e.text()).toInt(&xmlok, 10) == 0 ) {emit setonstin (FALSE); onstin(0);}; 
                  if ( (e.text()).toInt(&xmlok, 10) == 1 ) emit setonstin (TRUE);
              }

              if (e.tagName() == "OnRet1") {
                  if ( (e.text()).toInt(&xmlok, 10) == 0 ) {emit setonret1 (FALSE); onret1(0);}; 
                  if ( (e.text()).toInt(&xmlok, 10) == 1 ) emit setonret1 (TRUE);
              }

              if (e.tagName() == "OnRet2") {
                  if ( (e.text()).toInt(&xmlok, 10) == 0 ) {emit setonret2 (FALSE); onret2(0);}; 
                  if ( (e.text()).toInt(&xmlok, 10) == 1 ) emit setonret2 (TRUE);
              }

              if (e.tagName() == "OnRet3") {
                  if ( (e.text()).toInt(&xmlok, 10) == 0 ) {emit setonret3 (FALSE); onret3(0);}; 
                  if ( (e.text()).toInt(&xmlok, 10) == 1 ) emit setonret3 (TRUE);
              }

              if (e.tagName() == "OnRet4") {
                  if ( (e.text()).toInt(&xmlok, 10) == 0 ) {emit setonret4 (FALSE); onret4(0);}; 
                  if ( (e.text()).toInt(&xmlok, 10) == 1 ) emit setonret4 (TRUE);
              }


              if (e.tagName() == "OnStout") {
                  if ( (e.text()).toInt(&xmlok, 10) == 0 ) {emit setonstout (FALSE); onstout(0);}; 
                  if ( (e.text()).toInt(&xmlok, 10) == 1 ) emit setonstout (TRUE);
              }

              //--------------------------------------------------------------//

              if (e.tagName() == "Pan1") {
                  emit setpan1 (((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Pan2") {
                  emit setpan2 (((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Pan3") {
                  emit setpan3 (((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Pan4") {
                  emit setpan4 (((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Pan5") {
                  emit setpan5 (((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Pan6") {
                  emit setpan6 (((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Pan7") {
                  emit setpan7 (((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Pan8") {
                  emit setpan8 (((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Pan9") {
                  emit setpan9 (((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Pan10") {
                  emit setpan10 (((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Pan11") {
                  emit setpan11 (((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Pan12") {
                  emit setpan12 (((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Pan13") {
                  emit setpan13 (((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Pan14") {
                  emit setpan14 (((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Pan15") {
                  emit setpan15 (((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "Pan16") {
                  emit setpan16 (((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "PanStinL") {
                  emit setpanstinl (((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "PanStinR") {
                  emit setpanstinr (((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "PanRet1L") {
                  emit setpansend1l (((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "PanRet1R") {
                  emit setpansend1r (((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "PanRet2L") {
                  emit setpansend2l (((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "PanRet2R") {
                  emit setpansend2r (((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "PanRet3") {
                  emit setpansend3 (((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "PanRet4") {
                  emit setpansend4 (((e.text()).toInt(&xmlok, 10)));
              }

              if (e.tagName() == "PanStout") {
                  emit setpanstout (((e.text()).toInt(&xmlok, 10)));
              }

        }

        n = n.nextSibling();
    }

conf_loaded = 1;
run ();

}

}

//----------------------------------------------------------------------------//

void dmidi::save_config ()
{
    QString value;
    QDomDocument doc ("");

    QDomElement config = doc.createElement ("config");
    config.setAttribute ("id", "dpromix01");
    doc.appendChild (config);
    QDomText textVal;

    QDomElement iface = doc.createElement ("Interface");
    textVal = doc.createTextNode (interface);
    iface.appendChild (textVal);
    config.appendChild (iface);

    //------------------------------------------------------------------------//

    QDomElement node1 = doc.createElement ("Node1");
    value = value.setNum (n1, 16);
    textVal = doc.createTextNode (value);
    node1.appendChild (textVal);
    config.appendChild (node1);

    QDomElement node2 = doc.createElement ("Node2");
    value = value.setNum (n2, 16);
    textVal = doc.createTextNode (value);
    node2.appendChild (textVal);
    config.appendChild (node2);

    QDomElement node3 = doc.createElement ("Node3");
    value = value.setNum (n3, 16);
    textVal = doc.createTextNode (value);
    node3.appendChild (textVal);
    config.appendChild (node3);

    QDomElement node4 = doc.createElement ("Node4");
    value = value.setNum (n4, 16);
    textVal = doc.createTextNode (value);
    node4.appendChild (textVal);
    config.appendChild (node4);

    QDomElement node_name = doc.createElement ("NodeName");
    textVal = doc.createTextNode (nodename);
    node_name.appendChild (textVal);
    config.appendChild (node_name);

    QDomElement midich = doc.createElement ("MidiChan");
    value = value.setNum (midic, 10);
    textVal = doc.createTextNode (value);
    midich.appendChild (textVal);
    config.appendChild (midich);

    //------------------------------------------------------------------------//

    QDomElement s1val = doc.createElement ("Slider1Val");
    value = value.setNum (slider1val, 10);
    textVal = doc.createTextNode (value);
    s1val.appendChild (textVal);
    config.appendChild (s1val);

    QDomElement s2val = doc.createElement ("Slider2Val");
    value = value.setNum (slider2val, 10);
    textVal = doc.createTextNode (value);
    s2val.appendChild (textVal);
    config.appendChild (s2val);

    QDomElement s3val = doc.createElement ("Slider3Val");
    value = value.setNum (slider3val, 10);
    textVal = doc.createTextNode (value);
    s3val.appendChild (textVal);
    config.appendChild (s3val);

    QDomElement s4val = doc.createElement ("Slider4Val");
    value = value.setNum (slider4val, 10);
    textVal = doc.createTextNode (value);
    s4val.appendChild (textVal);
    config.appendChild (s4val);

    QDomElement s5val = doc.createElement ("Slider5Val");
    value = value.setNum (slider5val, 10);
    textVal = doc.createTextNode (value);
    s5val.appendChild (textVal);
    config.appendChild (s5val);

    QDomElement s6val = doc.createElement ("Slider6Val");
    value = value.setNum (slider6val, 10);
    textVal = doc.createTextNode (value);
    s6val.appendChild (textVal);
    config.appendChild (s6val);

    QDomElement s7val = doc.createElement ("Slider7Val");
    value = value.setNum (slider7val, 10);
    textVal = doc.createTextNode (value);
    s7val.appendChild (textVal);
    config.appendChild (s7val);

    QDomElement s8val = doc.createElement ("Slider8Val");
    value = value.setNum (slider8val, 10);
    textVal = doc.createTextNode (value);
    s8val.appendChild (textVal);
    config.appendChild (s8val);

    QDomElement s9val = doc.createElement ("Slider9Val");
    value = value.setNum (slider9val, 10);
    textVal = doc.createTextNode (value);
    s9val.appendChild (textVal);
    config.appendChild (s9val);

    QDomElement s10val = doc.createElement ("Slider10Val");
    value = value.setNum (slider10val, 10);
    textVal = doc.createTextNode (value);
    s10val.appendChild (textVal);
    config.appendChild (s10val);

    QDomElement s11val = doc.createElement ("Slider11Val");
    value = value.setNum (slider11val, 10);
    textVal = doc.createTextNode (value);
    s11val.appendChild (textVal);
    config.appendChild (s11val);

    QDomElement s12val = doc.createElement ("Slider12Val");
    value = value.setNum (slider12val, 10);
    textVal = doc.createTextNode (value);
    s12val.appendChild (textVal);
    config.appendChild (s12val);

    QDomElement s13val = doc.createElement ("Slider13Val");
    value = value.setNum (slider13val, 10);
    textVal = doc.createTextNode (value);
    s13val.appendChild (textVal);
    config.appendChild (s13val);

    QDomElement s14val = doc.createElement ("Slider14Val");
    value = value.setNum (slider14val, 10);
    textVal = doc.createTextNode (value);
    s14val.appendChild (textVal);
    config.appendChild (s14val);

    QDomElement s15val = doc.createElement ("Slider15Val");
    value = value.setNum (slider15val, 10);
    textVal = doc.createTextNode (value);
    s15val.appendChild (textVal);
    config.appendChild (s15val);

    QDomElement s16val = doc.createElement ("Slider16Val");
    value = value.setNum (slider16val, 10);
    textVal = doc.createTextNode (value);
    s16val.appendChild (textVal);
    config.appendChild (s16val);

    QDomElement sstinval = doc.createElement ("SliderStinVal");
    value = value.setNum (sliderstinval, 10);
    textVal = doc.createTextNode (value);
    sstinval.appendChild (textVal);
    config.appendChild (sstinval);

    QDomElement sret1val = doc.createElement ("SliderRet1Val");
    value = value.setNum (sliderret1val, 10);
    textVal = doc.createTextNode (value);
    sret1val.appendChild (textVal);
    config.appendChild (sret1val);

    QDomElement sret2val = doc.createElement ("SliderRet2Val");
    value = value.setNum (sliderret2val, 10);
    textVal = doc.createTextNode (value);
    sret2val.appendChild (textVal);
    config.appendChild (sret2val);

    QDomElement sret3val = doc.createElement ("SliderRet3Val");
    value = value.setNum (sliderret3val, 10);
    textVal = doc.createTextNode (value);
    sret3val.appendChild (textVal);
    config.appendChild (sret3val);

    QDomElement sret4val = doc.createElement ("SliderRet4Val");
    value = value.setNum (sliderret4val, 10);
    textVal = doc.createTextNode (value);
    sret4val.appendChild (textVal);
    config.appendChild (sret4val);

    QDomElement sstoutval = doc.createElement ("SliderStoutVal");
    value = value.setNum (sliderstoutval, 10);
    textVal = doc.createTextNode (value);
    sstoutval.appendChild (textVal);
    config.appendChild (sstoutval);

    //------------------------------------------------------------------------//

    QDomElement volval1 = doc.createElement ("Vol1");
    value = value.setNum (vol1, 10);
    textVal = doc.createTextNode (value);
    volval1.appendChild (textVal);
    config.appendChild (volval1);

    QDomElement volval2 = doc.createElement ("Vol2");
    value = value.setNum (vol2, 10);
    textVal = doc.createTextNode (value);
    volval2.appendChild (textVal);
    config.appendChild (volval2);

    QDomElement volval3 = doc.createElement ("Vol3");
    value = value.setNum (vol3, 10);
    textVal = doc.createTextNode (value);
    volval3.appendChild (textVal);
    config.appendChild (volval3);

    QDomElement volval4 = doc.createElement ("Vol4");
    value = value.setNum (vol4, 10);
    textVal = doc.createTextNode (value);
    volval4.appendChild (textVal);
    config.appendChild (volval4);

    QDomElement volval5 = doc.createElement ("Vol5");
    value = value.setNum (vol5, 10);
    textVal = doc.createTextNode (value);
    volval5.appendChild (textVal);
    config.appendChild (volval5);

    QDomElement volval6 = doc.createElement ("Vol6");
    value = value.setNum (vol6, 10);
    textVal = doc.createTextNode (value);
    volval6.appendChild (textVal);
    config.appendChild (volval6);

    QDomElement volval7 = doc.createElement ("Vol7");
    value = value.setNum (vol7, 10);
    textVal = doc.createTextNode (value);
    volval7.appendChild (textVal);
    config.appendChild (volval7);

    QDomElement volval8 = doc.createElement ("Vol8");
    value = value.setNum (vol8, 10);
    textVal = doc.createTextNode (value);
    volval8.appendChild (textVal);
    config.appendChild (volval8);

    QDomElement volval9 = doc.createElement ("Vol9");
    value = value.setNum (vol9, 10);
    textVal = doc.createTextNode (value);
    volval9.appendChild (textVal);
    config.appendChild (volval9);

    QDomElement volval10 = doc.createElement ("Vol10");
    value = value.setNum (vol10, 10);
    textVal = doc.createTextNode (value);
    volval10.appendChild (textVal);
    config.appendChild (volval10);

    QDomElement volval11 = doc.createElement ("Vol11");
    value = value.setNum (vol11, 10);
    textVal = doc.createTextNode (value);
    volval11.appendChild (textVal);
    config.appendChild (volval11);

    QDomElement volval12 = doc.createElement ("Vol12");
    value = value.setNum (vol12, 10);
    textVal = doc.createTextNode (value);
    volval12.appendChild (textVal);
    config.appendChild (volval12);

    QDomElement volval13 = doc.createElement ("Vol13");
    value = value.setNum (vol13, 10);
    textVal = doc.createTextNode (value);
    volval13.appendChild (textVal);
    config.appendChild (volval13);

    QDomElement volval14 = doc.createElement ("Vol14");
    value = value.setNum (vol14, 10);
    textVal = doc.createTextNode (value);
    volval14.appendChild (textVal);
    config.appendChild (volval14);

    QDomElement volval15 = doc.createElement ("Vol15");
    value = value.setNum (vol15, 10);
    textVal = doc.createTextNode (value);
    volval15.appendChild (textVal);
    config.appendChild (volval15);

    QDomElement volval16 = doc.createElement ("Vol16");
    value = value.setNum (vol16, 10);
    textVal = doc.createTextNode (value);
    volval16.appendChild (textVal);
    config.appendChild (volval16);

    QDomElement volval17 = doc.createElement ("VolStin");
    value = value.setNum (volstin, 10);
    textVal = doc.createTextNode (value);
    volval17.appendChild (textVal);
    config.appendChild (volval17);

    QDomElement volval18 = doc.createElement ("VolRet1");
    value = value.setNum (volret1, 10);
    textVal = doc.createTextNode (value);
    volval18.appendChild (textVal);
    config.appendChild (volval18);

    QDomElement volval19 = doc.createElement ("VolRet2");
    value = value.setNum (volret2, 10);
    textVal = doc.createTextNode (value);
    volval19.appendChild (textVal);
    config.appendChild (volval19);

    QDomElement volval20 = doc.createElement ("VolRet3");
    value = value.setNum (volret3, 10);
    textVal = doc.createTextNode (value);
    volval20.appendChild (textVal);
    config.appendChild (volval20);

    QDomElement volval21 = doc.createElement ("VolRet4");
    value = value.setNum (volret4, 10);
    textVal = doc.createTextNode (value);
    volval21.appendChild (textVal);
    config.appendChild (volval21);

    QDomElement volval22 = doc.createElement ("VolStout");
    value = value.setNum (volstout, 10);
    textVal = doc.createTextNode (value);
    volval22.appendChild (textVal);
    config.appendChild (volval22);

    //------------------------------------------------------------------------//

    QDomElement on1val = doc.createElement ("On1Val");
    value = value.setNum (onval1, 10);
    textVal = doc.createTextNode (value);
    on1val.appendChild (textVal);
    config.appendChild (on1val);

    QDomElement on2val = doc.createElement ("On2Val");
    value = value.setNum (onval2, 10);
    textVal = doc.createTextNode (value);
    on2val.appendChild (textVal);
    config.appendChild (on2val);

    QDomElement on3val = doc.createElement ("On3Val");
    value = value.setNum (onval3, 10);
    textVal = doc.createTextNode (value);
    on3val.appendChild (textVal);
    config.appendChild (on3val);

    QDomElement on4val = doc.createElement ("On4Val");
    value = value.setNum (onval4, 10);
    textVal = doc.createTextNode (value);
    on4val.appendChild (textVal);
    config.appendChild (on4val);

    QDomElement on5val = doc.createElement ("On5Val");
    value = value.setNum (onval5, 10);
    textVal = doc.createTextNode (value);
    on5val.appendChild (textVal);
    config.appendChild (on5val);

    QDomElement on6val = doc.createElement ("On6Val");
    value = value.setNum (onval6, 10);
    textVal = doc.createTextNode (value);
    on6val.appendChild (textVal);
    config.appendChild (on6val);

    QDomElement on7val = doc.createElement ("On7Val");
    value = value.setNum (onval7, 10);
    textVal = doc.createTextNode (value);
    on7val.appendChild (textVal);
    config.appendChild (on7val);

    QDomElement on8val = doc.createElement ("On8Val");
    value = value.setNum (onval8, 10);
    textVal = doc.createTextNode (value);
    on8val.appendChild (textVal);
    config.appendChild (on8val);

    QDomElement on9val = doc.createElement ("On9Val");
    value = value.setNum (onval9, 10);
    textVal = doc.createTextNode (value);
    on9val.appendChild (textVal);
    config.appendChild (on9val);

    QDomElement on10val = doc.createElement ("On10Val");
    value = value.setNum (onval10, 10);
    textVal = doc.createTextNode (value);
    on10val.appendChild (textVal);
    config.appendChild (on10val);

    QDomElement on11val = doc.createElement ("On11Val");
    value = value.setNum (onval11, 10);
    textVal = doc.createTextNode (value);
    on11val.appendChild (textVal);
    config.appendChild (on11val);

    QDomElement on12val = doc.createElement ("On12Val");
    value = value.setNum (onval12, 10);
    textVal = doc.createTextNode (value);
    on12val.appendChild (textVal);
    config.appendChild (on12val);

    QDomElement on13val = doc.createElement ("On13Val");
    value = value.setNum (onval13, 10);
    textVal = doc.createTextNode (value);
    on13val.appendChild (textVal);
    config.appendChild (on13val);

    QDomElement on14val = doc.createElement ("On14Val");
    value = value.setNum (onval14, 10);
    textVal = doc.createTextNode (value);
    on14val.appendChild (textVal);
    config.appendChild (on14val);

    QDomElement on15val = doc.createElement ("On15Val");
    value = value.setNum (onval15, 10);
    textVal = doc.createTextNode (value);
    on15val.appendChild (textVal);
    config.appendChild (on15val);

    QDomElement on16val = doc.createElement ("On16Val");
    value = value.setNum (onval16, 10);
    textVal = doc.createTextNode (value);
    on16val.appendChild (textVal);
    config.appendChild (on16val);

    QDomElement onstinval = doc.createElement ("OnStinVal");
    value = value.setNum (onvalstin, 10);
    textVal = doc.createTextNode (value);
    onstinval.appendChild (textVal);
    config.appendChild (onstinval);

    QDomElement onret1val = doc.createElement ("OnRet1Val");
    value = value.setNum (onvalret1, 10);
    textVal = doc.createTextNode (value);
    onret1val.appendChild (textVal);
    config.appendChild (onret1val);

    QDomElement onret2val = doc.createElement ("OnRet2Val");
    value = value.setNum (onvalret2, 10);
    textVal = doc.createTextNode (value);
    onret2val.appendChild (textVal);
    config.appendChild (onret2val);

    QDomElement onret3val = doc.createElement ("OnRet3Val");
    value = value.setNum (onvalret3, 10);
    textVal = doc.createTextNode (value);
    onret3val.appendChild (textVal);
    config.appendChild (onret3val);

    QDomElement onret4val = doc.createElement ("OnRet4Val");
    value = value.setNum (onvalret4, 10);
    textVal = doc.createTextNode (value);
    onret4val.appendChild (textVal);
    config.appendChild (onret4val);

    QDomElement onstoutval = doc.createElement ("OnStoutVal");
    value = value.setNum (onvalstout, 10);
    textVal = doc.createTextNode (value);
    onstoutval.appendChild (textVal);
    config.appendChild (onstoutval);

    //------------------------------------------------------------------------//

    QDomElement on1 = doc.createElement ("On1");
    value = value.setNum (on_val1, 10);
    textVal = doc.createTextNode (value);
    on1.appendChild (textVal);
    config.appendChild (on1);

    QDomElement on2 = doc.createElement ("On2");
    value = value.setNum (on_val2, 10);
    textVal = doc.createTextNode (value);
    on2.appendChild (textVal);
    config.appendChild (on2);

    QDomElement on3 = doc.createElement ("On3");
    value = value.setNum (on_val3, 10);
    textVal = doc.createTextNode (value);
    on3.appendChild (textVal);
    config.appendChild (on3);

    QDomElement on4 = doc.createElement ("On4");
    value = value.setNum (on_val4, 10);
    textVal = doc.createTextNode (value);
    on4.appendChild (textVal);
    config.appendChild (on4);

    QDomElement on5 = doc.createElement ("On5");
    value = value.setNum (on_val5, 10);
    textVal = doc.createTextNode (value);
    on5.appendChild (textVal);
    config.appendChild (on5);

    QDomElement on6 = doc.createElement ("On6");
    value = value.setNum (on_val6, 10);
    textVal = doc.createTextNode (value);
    on6.appendChild (textVal);
    config.appendChild (on6);

    QDomElement on7 = doc.createElement ("On7");
    value = value.setNum (on_val7, 10);
    textVal = doc.createTextNode (value);
    on7.appendChild (textVal);
    config.appendChild (on7);

    QDomElement on8 = doc.createElement ("On8");
    value = value.setNum (on_val8, 10);
    textVal = doc.createTextNode (value);
    on8.appendChild (textVal);
    config.appendChild (on8);

    QDomElement on9 = doc.createElement ("On9");
    value = value.setNum (on_val9, 10);
    textVal = doc.createTextNode (value);
    on9.appendChild (textVal);
    config.appendChild (on9);

    QDomElement on10 = doc.createElement ("On10");
    value = value.setNum (on_val10, 10);
    textVal = doc.createTextNode (value);
    on10.appendChild (textVal);
    config.appendChild (on10);

    QDomElement on11 = doc.createElement ("On11");
    value = value.setNum (on_val11, 10);
    textVal = doc.createTextNode (value);
    on11.appendChild (textVal);
    config.appendChild (on11);

    QDomElement on12 = doc.createElement ("On12");
    value = value.setNum (on_val12, 10);
    textVal = doc.createTextNode (value);
    on12.appendChild (textVal);
    config.appendChild (on12);

    QDomElement on13 = doc.createElement ("On13");
    value = value.setNum (on_val13, 10);
    textVal = doc.createTextNode (value);
    on13.appendChild (textVal);
    config.appendChild (on13);

    QDomElement on14 = doc.createElement ("On14");
    value = value.setNum (on_val14, 10);
    textVal = doc.createTextNode (value);
    on14.appendChild (textVal);
    config.appendChild (on14);

    QDomElement on15 = doc.createElement ("On15");
    value = value.setNum (on_val15, 10);
    textVal = doc.createTextNode (value);
    on15.appendChild (textVal);
    config.appendChild (on15);

    QDomElement on16 = doc.createElement ("On16");
    value = value.setNum (on_val16, 10);
    textVal = doc.createTextNode (value);
    on16.appendChild (textVal);
    config.appendChild (on16);

    QDomElement onstin = doc.createElement ("OnStin");
    value = value.setNum (on_valstin, 10);
    textVal = doc.createTextNode (value);
    onstin.appendChild (textVal);
    config.appendChild (onstin);

    QDomElement onret1 = doc.createElement ("OnRet1");
    value = value.setNum (on_valret1, 10);
    textVal = doc.createTextNode (value);
    onret1.appendChild (textVal);
    config.appendChild (onret1);

    QDomElement onret2 = doc.createElement ("OnRet2");
    value = value.setNum (on_valret2, 10);
    textVal = doc.createTextNode (value);
    onret2.appendChild (textVal);
    config.appendChild (onret2);

    QDomElement onret3 = doc.createElement ("OnRet3");
    value = value.setNum (on_valret3, 10);
    textVal = doc.createTextNode (value);
    onret3.appendChild (textVal);
    config.appendChild (onret3);

    QDomElement onret4 = doc.createElement ("OnRet4");
    value = value.setNum (on_valret4, 10);
    textVal = doc.createTextNode (value);
    onret4.appendChild (textVal);
    config.appendChild (onret4);

    QDomElement onstout = doc.createElement ("OnStout");
    value = value.setNum (on_valstout, 10);
    textVal = doc.createTextNode (value);
    onstout.appendChild (textVal);
    config.appendChild (onstout);



    //------------------------------------------------------------------------//

    QDomElement panval1 = doc.createElement ("Pan1");
    value = value.setNum (pan1, 10);
    textVal = doc.createTextNode (value);
    panval1.appendChild (textVal);
    config.appendChild (panval1);

    QDomElement panval2 = doc.createElement ("Pan2");
    value = value.setNum (pan2, 10);
    textVal = doc.createTextNode (value);
    panval2.appendChild (textVal);
    config.appendChild (panval2);

    QDomElement panval3 = doc.createElement ("Pan3");
    value = value.setNum (pan3, 10);
    textVal = doc.createTextNode (value);
    panval3.appendChild (textVal);
    config.appendChild (panval3);

    QDomElement panval4 = doc.createElement ("Pan4");
    value = value.setNum (pan4, 10);
    textVal = doc.createTextNode (value);
    panval4.appendChild (textVal);
    config.appendChild (panval4);

    QDomElement panval5 = doc.createElement ("Pan5");
    value = value.setNum (pan5, 10);
    textVal = doc.createTextNode (value);
    panval5.appendChild (textVal);
    config.appendChild (panval5);

    QDomElement panval6 = doc.createElement ("Pan6");
    value = value.setNum (pan6, 10);
    textVal = doc.createTextNode (value);
    panval6.appendChild (textVal);
    config.appendChild (panval6);

    QDomElement panval7 = doc.createElement ("Pan7");
    value = value.setNum (pan7, 10);
    textVal = doc.createTextNode (value);
    panval7.appendChild (textVal);
    config.appendChild (panval7);

    QDomElement panval8 = doc.createElement ("Pan8");
    value = value.setNum (pan8, 10);
    textVal = doc.createTextNode (value);
    panval8.appendChild (textVal);
    config.appendChild (panval8);

    QDomElement panval9 = doc.createElement ("Pan9");
    value = value.setNum (pan9, 10);
    textVal = doc.createTextNode (value);
    panval9.appendChild (textVal);
    config.appendChild (panval9);

    QDomElement panval10 = doc.createElement ("Pan10");
    value = value.setNum (pan10, 10);
    textVal = doc.createTextNode (value);
    panval10.appendChild (textVal);
    config.appendChild (panval10);

    QDomElement panval11 = doc.createElement ("Pan11");
    value = value.setNum (pan11, 10);
    textVal = doc.createTextNode (value);
    panval11.appendChild (textVal);
    config.appendChild (panval11);

    QDomElement panval12 = doc.createElement ("Pan12");
    value = value.setNum (pan12, 10);
    textVal = doc.createTextNode (value);
    panval12.appendChild (textVal);
    config.appendChild (panval12);

    QDomElement panval13 = doc.createElement ("Pan13");
    value = value.setNum (pan13, 10);
    textVal = doc.createTextNode (value);
    panval13.appendChild (textVal);
    config.appendChild (panval13);

    QDomElement panval14 = doc.createElement ("Pan14");
    value = value.setNum (pan14, 10);
    textVal = doc.createTextNode (value);
    panval14.appendChild (textVal);
    config.appendChild (panval14);

    QDomElement panval15 = doc.createElement ("Pan15");
    value = value.setNum (pan15, 10);
    textVal = doc.createTextNode (value);
    panval15.appendChild (textVal);
    config.appendChild (panval15);

    QDomElement panval16 = doc.createElement ("Pan16");
    value = value.setNum (pan16, 10);
    textVal = doc.createTextNode (value);
    panval16.appendChild (textVal);
    config.appendChild (panval16);

    QDomElement panvalstinl = doc.createElement ("PanStinL");
    value = value.setNum (panstinl, 10);
    textVal = doc.createTextNode (value);
    panvalstinl.appendChild (textVal);
    config.appendChild (panvalstinl);

    QDomElement panvalstinr = doc.createElement ("PanStinR");
    value = value.setNum (panstinr, 10);
    textVal = doc.createTextNode (value);
    panvalstinr.appendChild (textVal);
    config.appendChild (panvalstinr);

    QDomElement panvalret1l = doc.createElement ("PanRet1L");
    value = value.setNum (panret1l, 10);
    textVal = doc.createTextNode (value);
    panvalret1l.appendChild (textVal);
    config.appendChild (panvalret1l);

    QDomElement panvalret1r = doc.createElement ("PanRet1R");
    value = value.setNum (panret1r, 10);
    textVal = doc.createTextNode (value);
    panvalret1r.appendChild (textVal);
    config.appendChild (panvalret1r);

    QDomElement panvalret2l = doc.createElement ("PanRet2L");
    value = value.setNum (panret2l, 10);
    textVal = doc.createTextNode (value);
    panvalret2l.appendChild (textVal);
    config.appendChild (panvalret2l);

    QDomElement panvalret2r = doc.createElement ("PanRet2R");
    value = value.setNum (panret2r, 10);
    textVal = doc.createTextNode (value);
    panvalret2r.appendChild (textVal);
    config.appendChild (panvalret2r);

    QDomElement panvalret3 = doc.createElement ("PanRet3");
    value = value.setNum (panret3, 10);
    textVal = doc.createTextNode (value);
    panvalret3.appendChild (textVal);
    config.appendChild (panvalret3);

/*    QDomElement panvalret3r = doc.createElement ("PanRet3R");
    value = value.setNum (panret3r, 10);
    textVal = doc.createTextNode (value);
    panvalret3r.appendChild (textVal);
    config.appendChild (panvalret3r);

    QDomElement panvalret4l = doc.createElement ("PanRet4L");
    value = value.setNum (panret4l, 10);
    textVal = doc.createTextNode (value);
    panvalret4l.appendChild (textVal);
    config.appendChild (panvalret4l);
*/
    QDomElement panvalret4 = doc.createElement ("PanRet4");
    value = value.setNum (panret4, 10);
    textVal = doc.createTextNode (value);
    panvalret4.appendChild (textVal);
    config.appendChild (panvalret4);

    QDomElement panvalstout = doc.createElement ("PanStout");
    value = value.setNum (panstout, 10);
    textVal = doc.createTextNode (value);
    panvalstout.appendChild (textVal);
    config.appendChild (panvalstout);

    //------------------------------------------------------------------------//

    QDomElement pan1val = doc.createElement ("Pan1Val");
    value = value.setNum (p1val, 10);
    textVal = doc.createTextNode (value);
    pan1val.appendChild (textVal);
    config.appendChild (pan1val);

    QDomElement pan2val = doc.createElement ("Pan2Val");
    value = value.setNum (p2val, 10);
    textVal = doc.createTextNode (value);
    pan2val.appendChild (textVal);
    config.appendChild (pan2val);

    QDomElement pan3val = doc.createElement ("Pan3Val");
    value = value.setNum (p3val, 10);
    textVal = doc.createTextNode (value);
    pan3val.appendChild (textVal);
    config.appendChild (pan3val);

    QDomElement pan4val = doc.createElement ("Pan4Val");
    value = value.setNum (p4val, 10);
    textVal = doc.createTextNode (value);
    pan4val.appendChild (textVal);
    config.appendChild (pan4val);

    QDomElement pan5val = doc.createElement ("Pan5Val");
    value = value.setNum (p5val, 10);
    textVal = doc.createTextNode (value);
    pan5val.appendChild (textVal);
    config.appendChild (pan5val);

    QDomElement pan6val = doc.createElement ("Pan6Val");
    value = value.setNum (p6val, 10);
    textVal = doc.createTextNode (value);
    pan6val.appendChild (textVal);
    config.appendChild (pan6val);

    QDomElement pan7val = doc.createElement ("Pan7Val");
    value = value.setNum (p7val, 10);
    textVal = doc.createTextNode (value);
    pan7val.appendChild (textVal);
    config.appendChild (pan7val);

    QDomElement pan8val = doc.createElement ("Pan8Val");
    value = value.setNum (p8val, 10);
    textVal = doc.createTextNode (value);
    pan8val.appendChild (textVal);
    config.appendChild (pan8val);

    QDomElement pan9val = doc.createElement ("Pan9Val");
    value = value.setNum (p9val, 10);
    textVal = doc.createTextNode (value);
    pan9val.appendChild (textVal);
    config.appendChild (pan9val);

    QDomElement pan10val = doc.createElement ("Pan10Val");
    value = value.setNum (p10val, 10);
    textVal = doc.createTextNode (value);
    pan10val.appendChild (textVal);
    config.appendChild (pan10val);

    QDomElement pan11val = doc.createElement ("Pan11Val");
    value = value.setNum (p11val, 10);
    textVal = doc.createTextNode (value);
    pan11val.appendChild (textVal);
    config.appendChild (pan11val);

    QDomElement pan12val = doc.createElement ("Pan12Val");
    value = value.setNum (p12val, 10);
    textVal = doc.createTextNode (value);
    pan12val.appendChild (textVal);
    config.appendChild (pan12val);

    QDomElement pan13val = doc.createElement ("Pan13Val");
    value = value.setNum (p13val, 10);
    textVal = doc.createTextNode (value);
    pan13val.appendChild (textVal);
    config.appendChild (pan13val);

    QDomElement pan14val = doc.createElement ("Pan14Val");
    value = value.setNum (p14val, 10);
    textVal = doc.createTextNode (value);
    pan14val.appendChild (textVal);
    config.appendChild (pan14val);

    QDomElement pan15val = doc.createElement ("Pan15Val");
    value = value.setNum (p15val, 10);
    textVal = doc.createTextNode (value);
    pan15val.appendChild (textVal);
    config.appendChild (pan15val);

    QDomElement pan16val = doc.createElement ("Pan16Val");
    value = value.setNum (p16val, 10);
    textVal = doc.createTextNode (value);
    pan16val.appendChild (textVal);
    config.appendChild (pan16val);

    QDomElement panstinlval = doc.createElement ("PanStinLVal");
    value = value.setNum (pstinlval, 10);
    textVal = doc.createTextNode (value);
    panstinlval.appendChild (textVal);
    config.appendChild (panstinlval);

    QDomElement panstinrval = doc.createElement ("PanStinRVal");
    value = value.setNum (pstinrval, 10);
    textVal = doc.createTextNode (value);
    panstinrval.appendChild (textVal);
    config.appendChild (panstinrval);

    QDomElement panret1lval = doc.createElement ("PanRet1LVal");
    value = value.setNum (pret1lval, 10);
    textVal = doc.createTextNode (value);
    panret1lval.appendChild (textVal);
    config.appendChild (panret1lval);

    QDomElement panret1rval = doc.createElement ("PanRet1RVal");
    value = value.setNum (pret1rval, 10);
    textVal = doc.createTextNode (value);
    panret1rval.appendChild (textVal);
    config.appendChild (panret1rval);

    QDomElement panret2lval = doc.createElement ("PanRet2LVal");
    value = value.setNum (pret2lval, 10);
    textVal = doc.createTextNode (value);
    panret2lval.appendChild (textVal);
    config.appendChild (panret2lval);

    QDomElement panret2rval = doc.createElement ("PanRet2RVal");
    value = value.setNum (pret2rval, 10);
    textVal = doc.createTextNode (value);
    panret2rval.appendChild (textVal);
    config.appendChild (panret2rval);

    QDomElement panret3val = doc.createElement ("PanRet3Val");
    value = value.setNum (pret3val, 10);
    textVal = doc.createTextNode (value);
    panret3val.appendChild (textVal);
    config.appendChild (panret3val);

    QDomElement panret4val = doc.createElement ("PanRet4Val");
    value = value.setNum (pret4val, 10);
    textVal = doc.createTextNode (value);
    panret4val.appendChild (textVal);
    config.appendChild (panret4val);

    QDomElement panstoutval = doc.createElement ("PanStoutVal");
    value = value.setNum (pstoutval, 10);
    textVal = doc.createTextNode (value);
    panstoutval.appendChild (textVal);
    config.appendChild (panstoutval);

    //------------------------------------------------------------------------//
    // Open file for writing

    QFile file( "dpromix01.xml" );
    if ( file.open( IO_WriteOnly ) ) {
        QTextStream stream( &file );
        stream << doc.toString();
        file.close();
    } else {
        qDebug ("Failed to write DPromix01 XML Conf File.");
    }
}



void dmidi::run ()
{
//while (1) {
//    qDebug ("here\n");
//    sleep (1);
//    }
}

